=== debian/changelog ===
ros-melodic-moveit-opw-kinematics-plugin (0.2.1-1stretch) stretch; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Jeroen De Maeyer <jeroen.demaeyer@kuleuven.be>  Sun, 17 May 2020 08:19:54 -0000
